#include"micromegas_aux.h"
#include"micromegas.h"


//  Old form SD  factors

#define beta0(u,upi) ( ((upi)*(upi)/((u)+(upi))/((u)+(upi))-1.)/3.)
#define pimass (0.135/0.197327)
#define P01(u)  ( 0.1145*(u)*(u) - 0.6667*(u) + 1.)
#define P21(u)  (-0.0026*(u)*(u) + 0.0100*(u) )
#define Q01(u)  ( 0.1088*(u)*(u) - 0.6667*(u) + 1.)
#define Q21(u)  ( 0.0006*(u)*(u) + 0.0041*(u) )

#define J 0.5
#define A 19

void SxxF19(double q, double*S00,double*S01,double*S11)
{
  double q_fm=q;
  double bsq=pow(A,1./3.), u=0.5*bsq*q_fm*q_fm;
  
//  bsq=41.467/(45*pow(A,-1./3.) -25*pow(A,-2./3));
//  u=0.5*bsq*q_fm*q_fm;
  
  double upi=0.5*bsq*pimass*pimass;
  double p01=P01(u), p21=P21(u); 
  double q01=Q01(u), q21=Q21(u);  
  double be0=beta0(u,upi), be2=2*be0,be02=-sqrt(2.)*be0;
  
  *S00=((2*J+1)/16/M_PI)*2.610*exp(-u)*(p01*p01*(1+be0)+p21*p21*(1+be2)-2*be02*p01*p21);
  *S11=((2*J+1)/16/M_PI)*2.807*exp(-u)*(q01*q01*(1+be0)+q21*q21*(1+be2)-2*be02*q01*q21);
  *S01=((2*J+1)/ 8/M_PI)*2.707*exp(-u)*(p01*q01*(1+be0)+p21*q21*(1+be2)-be02*(p01*q21+p21*q01));            
}

#undef P01
#undef P21
#undef Q01
#undef Q21
#undef J 
#undef A 
//-------------------
#define P01(u)  ( 0.2843*(u)*(u) - 0.6667*(u)  + 1.)
#define P21(u)  ( -0.0567*(u)*(u) + 0.4566*(u))
#define Q01(u)  ( 0.2710*(u)*(u) - 0.6667*(u) + 1.)
#define Q21(u)  ( -0.0621*(u)*(u) + 0.4680*(u) )

#define J 0.5
#define A 29

void SxxSi29(double q, double*S00,double*S01,double*S11)
{ double q_fm=q;
  double bsq=pow(A,1./3.), u=0.5*bsq*q_fm*q_fm;
  double upi=0.5*bsq*pimass*pimass;
  double p01=P01(u),p21=P21(u); 
  double q01=Q01(u), q21=Q21(u);
  double be0=beta0(u,upi), be2=2*be0,be02=-sqrt(2.)*be0;
  *S00=((2*J+1)/16/M_PI)*0.208*exp(-u)*(p01*p01*(1+be0)+p21*p21*(1+be2)-2*be02*p01*p21);
  *S11=((2*J+1)/16/M_PI)*0.220*exp(-u)*(q01*q01*(1+be0)+q21*q21*(1+be2)-2*be02*q01*q21);
  *S01=((2*J+1)/8/M_PI)*(-sqrt(0.208*0.220))*exp(-u)*(p01*q01*(1+be0)+p21*q21*(1+be2)-be02*(p01*q21+p21*q01)); 
} 


#undef P01
#undef P21
#undef Q01
#undef Q21
#undef J 
#undef A 
// ------------------------------------------
#define P01(u)  ( 0.0477*u*u - 0.6667*u + 1)
#define P21(u)  (-0.0177*u*u + 0.1048*u)
#define P23(u)  (-0.0767*u*u + 0.6092*u)
#define P43(u)  ( 0.0221*u*u)

#define Q01(u)  ( 0.0465*u*u - 0.6667*u + 1)
#define Q21(u)  (-0.0349*u*u + 0.1494*u)
#define Q23(u)  (-0.0894*u*u + 0.7405*u)
#define Q43(u)  ( 0.0287*u*u)

#define J 1.5
#define A 23

/*========================= Na23 ===================*/
void SxxNa23A(double q, double*S00,double*S01,double*S11)
{
  double q_fm=q;
  double bsq=pow(A,1./3.), u=0.5*bsq*q_fm*q_fm;
  double p01=P01(u),p21=P21(u),p23=P23(u),p43=P43(u);
  double q01=Q01(u),q21=Q21(u),q23=Q23(u),q43=Q43(u); 
  *S00=((2*J+1)/16/M_PI)*(0.478)*exp(-u)*(p01*p01+p21*p21+p23*p23+p43*p43);
  *S01=((2*J+1)/8/M_PI)*(0.406)*exp(-u)*(p01*q01+p21*q21+p23*q23+p43*q43);
  *S11=((2*J+1)/16/M_PI)*(0.346)*exp(-u)*(q01*q01+q21*q21+q23*q23+q43*q43);
}

#undef P01
#undef P21
#undef P23
#undef P43
#undef Q01
#undef Q21
#undef Q23
#undef Q43
#undef J 
#undef A 
#undef b

/*--------- exponential parametrization --------*/

double static ss_exp_aux(double q, double A, double a,double b)
{   double q_fm=q, y=0.25*pow(A,1./3.)*q_fm*q_fm;
    return a*exp(-b*y);
}    

/*================= Si29A ======	=============== */ 
void SxxSi29A(double q,double *S00,double*S01,double*S11)
{ *S00=ss_exp_aux(q, 29,0.00818,4.428);
  *S01=ss_exp_aux(q, 29,0.00818*(-2.06),5.413);
  *S11=ss_exp_aux(q, 29,0.00818*1.06,6.264);
}  
/*================= Ge73A ===================== */
void SxxGe73A(double q,double *S00,double*S01,double*S11)
{
  *S00=ss_exp_aux(q,73,0.20313*1.102,7.468);
  *S01=ss_exp_aux(q,73,0.20313*(-2.099),8.191);
  *S11=ss_exp_aux(q,73,0.20313,8.856);
}
  
/*-------polinomial parametrization ----------------*/
 
static double SSxxYYzz(double q,double * data, int nData,int A,int expKey,double yN,double y_max)
{ int i;
  double q_fm=q, 
/*  y=0.25*pow((double)A,1./3.)*q_fm*q_fm, y_i,res;*/
    y=0.25*pow(A,1./3.)*(41.467/(45-25/pow(A,1./3.)))*q_fm*q_fm, y_i,res;

  if(y>y_max) return 0.;
  for(i=1,res=data[0],y_i=1;i<nData;i++) {y_i*=y; res+=y_i*data[i]; }
  res+=yN/(1+y);
  if(expKey) res*=exp(-2*y);
  return res;
} 

/*========================= Na23 ===================*/
void SxxNa23(double q, double*S00,double*S01,double*S11)
{ double data00[4]={0.0380,-0.1743,0.3783,-0.3430};
  double data01[4]={0.0647, -0.3503,0.9100,-0.9858};
  double data11[4]={0.0275,-0.1696,0.5077,-0.6180};
  *S00=SSxxYYzz(q,data00,4,23,0,0.,0.2);
  *S01=SSxxYYzz(q,data01,4,23,0,0.,0.2);
  *S11=SSxxYYzz(q,data11,4,23,0,0.,0.2);
}

/* ========================= Al27 ==================*/

void SxxAl27(double q,double*S00,double*S01,double*S11)
{
   double data00[4]={0.0930,-0.4721,1.0600,-1.0115};
   double data01[4]={0.1563,-0.9360,2.4578,-2.7262};
   double data11[4]={0.0657,-0.4498,1.3504,-1.6851};
   *S00=SSxxYYzz(q,data00,4,27,0,0.,0.3);
   *S01=SSxxYYzz(q,data01,4,27,0,0.,0.3);
   *S11=SSxxYYzz(q,data11,4,27,0,0.,0.3);
}
                           
/*============================== K39 =================*/

void SxxK39(double q,double*S00,double*S01,double*S11)
{
  double data00[5]={0.0094999,-0.0619718,0.162844,-0.194282,0.0891054};
  double data01[5]={0.0332044,-0.2319430,0.638528,-0.798523,0.3809750};
  double data11[5]={0.0298127,-0.2176360,0.623646,-0.814418,0.4050270};
  *S00=SSxxYYzz(q,data00,5,39,0,0.,0.6);
  *S01=SSxxYYzz(q,data01,5,39,0,0.,0.6);
  *S11=SSxxYYzz(q,data11,5,39,0,0.,0.6);
}

/*=========================== Ge73 =====================*/

void SxxGe73(double q,double*S00,double*S01,double*S11)
{
  double data00[7]={0.1606, -1.1052,3.2320,-4.9245,4.1229,-1.8016,0.3211};
  double data01[7]={-0.271006,2.018922,-6.226466,9.860608,-8.502157,3.800620,-0.689352};
  double data11[7]={0.1164,-0.9228,2.9753,-4.8709,4.3099,-1.9661,0.3624 };
  *S00=SSxxYYzz(q,data00,7,73,0,0.,1.3);
  *S01=SSxxYYzz(q,data01,7,73,0,0.,1.3);
  *S11=SSxxYYzz(q,data11,7,73,0,0.,1.3);
}


/* ========================= Nb93 ==================== */
void SxxNb93(double q,double*S00,double*S01,double*S11)
{ double  q2[9]= {0,    0.002,0.004,0.006,0.008,0.01, 0.014,0.02, 0.03};
  double s00[9]={0.284,0.19, 0.122,0.082,0.058,0.039,0.024,0.021,0.02};
  double s01[9]={0.4,0.26, 0.161,0.105,0.07, 0.046,0.029,0.026,0.024};
  double s11[9]={0.14,0.085,0.053,0.034,0.02, 0.012,0.0052,0.003,0.0025}; 
  double x=q*0.197327;
  x*=x; 
  if(x>0.03){ *S00=0; *S01=0; *S11=0; return;}
  *S00=polint3(x,9,q2,s00);
  *S01=polint3(x,9,q2,s01);
  *S11=polint3(x,9,q2,s11);
}  

/*============================ Xe131B =======================*/

void SxxXe131B(double q,double*S00,double*S01,double*S11)
{ double q2[11]= {0,0.0025,0.005,0.01,0.015,0.02,0.025,0.03,0.04,0.05,0.06};
  double s00[11]={0.04,0.0215,0.014,0.01,0.009,0.008,0.0075,0.0066,0.005,0.0035,0.0017};
  double s01[11]={ -0.056,-0.028,-0.019,-0.013,-0.01,-0.009,-0.008,-0.007,-0.005,-0.003,-0.001 };
  double s11[11]={0.020,0.009,0.006,0.004,0.003,0.0027,0.0025,0.0023,0.0019,0.0015,0.001};
  double x=q*0.197327;
  x*=x;
  if(x>0.06) { *S00=0; *S01=0; *S11=0; return;} 
  *S00= polint3(x,11,q2,s00);
  *S01= polint3(x,11,q2,s01);
  *S11= polint3(x,11,q2,s11);
}

void SxxXe131Me(double q,double*S00,double*S01,double*S11) // Menendez et al.;  1208.1094
{
  double data00[10]={ 0.0417889, -0.111171 , 0.171966, -0.133219 ,  0.0633805, -0.0178388,  0.00282476, -2.31681E-4, 7.78223E-6, -4.49287E-10};
  double data11[10]={ 0.022446 , -0.0733931, 0.110509, -0.0868752,  0.0405399, -0.0113544,  0.00187572, -1.75285E-4, 8.40043E-6, -1.53632E-7 };
  double data01[10]={-0.0608808,  0.181473 ,-0.272533,  0.211776 , -0.0985956,  0.027438 , -0.0044424 ,  3.97619E-4,-1.74758E-5,  2.55979E-7 };

  double b=2.2905; // fm 
  double u=q*q*b*b/2;
  
  *S00=data00[0],*S01=data01[0]; *S11=data11[0];
  double un=u;
  for(int i=1;i<10;i++) { *S00+=un*data00[i];*S01+=un*data01[i];*S11+=un*data11[i]; un*=u;}
  *S00*=exp(-u); *S01*=exp(-u); *S11*=exp(-u);  
}

/*============================ Te125 =======================*/

void SxxTe125(double q,double*S00,double*S01,double*S11)
{
  double data00[9]={0.03971,-0.19610, 0.47265,-0.65023, 0.54193,-0.26456, 0.07489,-0.01146,0.00075};
  double data01[9]={-0.07894, 0.42738,-1.09331, 1.55324,-1.28933, 0.61844,-0.16964, 0.02481,-0.00152};
  double data11[9]={ 0.03922,-0.22938,0.62215,-0.92253,0.78465,-0.38245,0.1057,-0.01542,0.00093 };
  *S00=SSxxYYzz(q,data00,9,125,1,0.,10.);
  *S01=SSxxYYzz(q,data01,9,125,1,0.,10.);
  *S11=SSxxYYzz(q,data11,9,125,1,0.,10.); 
}


/*============================ I127 =======================*/

void SxxI127(double q,double*S00,double*S01,double*S11)
{
  double data00[9]={0.0983,-0.4891,1.1402,-1.4717,1.1717,-0.5646,0.1583,-0.0239,0.0015};
  double data01[9]={0.1199,-0.6184,1.5089,-2.0737,1.7731,-0.9036,0.2600,-0.0387,0.0024};
  double data11[9]={0.0366,-0.1950,0.5049,-0.7475,0.7043,-0.3930,0.1219,-0.0192,0.0012};
  *S00=SSxxYYzz(q,data00,9,127,1,0.,10.);
  *S01=SSxxYYzz(q,data01,9,127,1,0.,10.);
  *S11=SSxxYYzz(q,data11,9,127,1,0.,10.);
}


/*============================ Xe129 =======================*/
void SxxXe129(double q,double*S00,double*S01,double*S11)
{
  double data00[9]={0.07132,-0.34478, 0.75590,-0.93345, 0.69006,-0.30248, 0.07653,-0.01032, 0.00057};
  double data01[9]={-0.12166, 0.64435,-1.52732, 2.02061,-1.57689, 0.72398,-0.19040, 0.02638,-0.00149};
  double data11[9]={-2.05825, 1.80756,-1.27746, 0.65459,-0.22197, 0.04546,-0.00427,-0.00014, 0.00004};

  *S00=SSxxYYzz(q,data00,9,129,1,0.,10.);
  *S01=SSxxYYzz(q,data01,9,129,1,0.,10.);
  *S11=SSxxYYzz(q,data11,9,129,1,2.11016,10.);  
}

void SxxXe129M(double q,double*S00,double*S01,double*S11)
{
double data00[10]={ 0.054731, -0.146897,  0.182479,-0.128112,  0.0539978, -0.0133335,  0.00190579, -1.48373E-4,  5.11732E-6, -2.06597E-8};
double data11[10]={ 0.02933,  -0.0905396, 0.122783,-0.0912046, 0.0401076, -0.010598,   0.00168737, -1.56768E-4,  7.69202E-6, -1.48874E-7};
double data01[10]={-0.0796645, 0.231997, -0.304198, 0.222024, -0.096693,   0.0251835, -0.00392356,  3.53343E-4, -1.65058E-5,  2.88576E-7};

  double b=2.2853; // fm 
  double u=q*q*b*b/2;
  
  *S00=data00[0],*S01=data01[0]; *S11=data11[0];
  double un=u;
  for(int i=1;i<10;i++) { *S00+=un*data00[i];*S01+=un*data01[i];*S11+=un*data11[i]; un*=u;}
  *S00*=exp(-u); *S01*=exp(-u); *S11*=exp(-u);  
}

/*============================ Xe131 =======================*/

void SxxXe131(double q,double*S00,double*S01,double*S11)
{
  double data00[9]={ 0.02964,-0.13343, 0.37799,-0.57961, 0.57890,-0.34556, 0.11595,-0.02012, 0.00142}; 
  double data01[9]={-0.05455, 0.27176,-0.72302, 1.05450,-0.97133, 0.53842,-0.16899, 0.02742,-0.00181};
  double data11[9]={ 0.02510,-0.13772,0.36661,-0.53851, 0.49255,-0.26990, 0.08369,-0.01340, 0.00087};

  *S00=SSxxYYzz(q,data00,9,131,1,0.,10.);
  *S01=SSxxYYzz(q,data01,9,131,1,0.,10.);
  *S11=SSxxYYzz(q,data11,9,131,1,0.,10.);   
}

/*============================ Te125A =======================*/

void SxxTe125A(double q,double*S00,double*S01,double*S11)
{
  double data00[9]={ 0.04960,-0.24777,0.54766,-0.66553,0.47462,-0.19944,0.04819,-0.00616,0.00032};
  double data01[9]={-0.09939,0.54303,-1.28816,1.67206,-1.26883,0.56728,-0.14545,0.01959,-0.00107};
  double data11[9]={-1.92941,1.68075,-1.16336,0.58650,-0.20730,0.05141,-0.00870,0.00087,0.00004};
  *S00=SSxxYYzz(q,data00,9,125,1,0.,10.);
  *S01=SSxxYYzz(q,data01,9,125,1,0.,10.);
  *S11=SSxxYYzz(q,data01,9,125,1,1.97923,10.);
}
/*============================ I127 =======================*/

void SxxI127A(double q,double*S00,double*S01,double*S11)
{
  double data00[9]={0.1166,-0.5721,1.3380,-1.7252,1.3774,-0.6700,0.1905,-0.0292,0.0019};
  double data01[9]={0.1621,-0.8363,2.0594,-2.8319,2.3973,-1.2121,0.3486,-0.0522,0.0032}; 
  double data11[9]={0.0563,-0.3038,0.7948,-1.1703,1.0637,-0.5713,0.1722,-0.0266,0.0017};
  *S00=SSxxYYzz(q,data00,9,127,1,0.,10.);
  *S01=SSxxYYzz(q,data01,9,127,1,0.,10.);
  *S11=SSxxYYzz(q,data11,9,127,1,0.,10.);
}


/*============================ Xe129A =======================*/

void SxxXe129A(double q,double*S00,double*S01,double*S11)
{
  double data00[9]={0.04649,-0.22551,0.49905,-0.62244,0.46361,-0.20375,0.05109,-0.00671,0.00036};
  double data01[9]={-0.08538,0.45343,-1.06546,1.38670,-1.05940,0.47576,-0.12208,0.01643,-0.00089};
  double data11[9]={-1.28214,1.09276,-0.71295,0.31489,-0.08351,0.01059,0.00023,-0.00024,0.00002};
    
  *S00=SSxxYYzz(q,data00,9,129,1,0.,10.);
  *S01=SSxxYYzz(q,data01,9,129,1,0.,10.);
  *S11=SSxxYYzz(q,data11,9,129,1,1.32136,10.);
}

/*============================ Xe131A =======================*/

void SxxXe131A(double q,double*S00,double*S01,double*S11)
{
  double data00[9]={0.02773,-0.12449,0.32829,-0.48140,0.47565,-0.28518,0.09682,-0.01710,0.00124};
  double data01[9]={-0.04978,0.24725,-0.63231,0.89642,-0.81645,0.45235,-0.14267,0.02335,-0.00156};
  double data11[9]={0.02234,-0.12206,0.31949,-0.46695,0.42877,-0.23679,0.07408,-0.01197,0.00079};
  
  *S00=SSxxYYzz(q,data00,9,131,1,0.,10.);
  *S01=SSxxYYzz(q,data01,9,131,1,0.,10.);
  *S11=SSxxYYzz(q,data11,9,131,1,0.,10.); 
}


/*============================ Pb207 =======================*/

static double _u_;
static double  _fPb_integrand(double x)
{ double u=_u_*x;
  return exp(-u/2)*(1.-u*(5./3.-u*(17./15.-u*(31./105.-u*( 9./280.-u*1./840.)))));
}

void SxxPb207(double q,double*S00,double*S01,double*S11)
{
  _u_=0.5*pow(207.,1./3.)*(q)*(q);
  *S00=((2*0.5+1)/16/M_PI)*0.305*simpson(_fPb_integrand,0.,1.,1.E-4,NULL);
  *S01=*S00*(-2)*0.266/0.305; 
  *S11=*S00*0.231/0.305;
}

//====  EFT SD form factors     1203.3542

void SxxF19EFT(double q, double*S00,double*S01,double*S11)
{
  double  J=0.5,A=19;

  double b=sqrt(41.467/(45*pow(A,-1./3.) -25*pow(A,-2./3)));
  double y=pow(b*q/2,2);

  double CJ=J*(J+1)/12;
  
  double Fpp= CJ*exp(-2*y)*(1.81  -4.85*y +4.88*y*y -2.18*y*y*y +0.364*y*y*y*y
                       +0.903 -2.37*y +2.35*y*y -1.05*y*y*y +0.175*y*y*y*y);
  double Fpn= CJ*exp(-2*y)*(-0.0331+0.0815*y +0.0511 *y*y -0.00142*y*y*y +0.00602*y*y*y*y
                        -0.0166+0.0509*y -0.0510 *y*y +0.0199*y*y*y -0.00237*y*y*y*y );
  double Fnn= CJ*exp(-2*y)*(0.000607-0.00136*y +0.000266*y*y +0.000550*y*y*y +0.0000997*y*y*y*y
                       +0.000303-0.00107*y +0.00114*y*y -0.000348*y*y*y +0.0000320*y*y*y*y);
  
 *S00=   (2*J+1)/M_PI*(Fpp+Fnn+2*Fpn);
 *S11=   (2*J+1)/M_PI*(Fpp+Fnn-2*Fpn);
 *S01= 2*(2*J+1)/M_PI*(Fpp-Fnn);

}



void SxxXe129EFT(double q,double*S00,double*S01,double*S11) 
{

  double A=129, J=J_Xe129;
  double b=sqrt(41.467/(45*pow(A,-1./3.) -25*pow(A,-2./3)));
  double y=pow(b*q/2,2);


  double CJ=J*(J+1)/12;
  double y2=y*y, y3=y*y2, y4=y*y3, y5=y*y4, y6=y*y5,y7=y*y6, y8=y*y7;
     
  double Fpp= CJ*exp(-2*y)*(0.00042 - 0.0019*y+ 0.0065*y2  - 0.012*y3  + 0.017*y4  - 0.012*y5  + 0.0041*y6  - 0.00063*y7
                           +0.00021 - 0.0015*y+ 0.0043*y2 - 0.0063*y3 + 0.0049*y4 - 0.0020*y5 + 0.00042*y6                         );
  double Fpn= CJ*exp(-2*y)*(0.014   - 0.080*y + 0.23*y2   - 0.41*y3   + 0.43*y4   - 0.24*y5   + 0.070*y6   - 0.010*y7 + 0.00058*y8
                           +0.0072  - 0.038*y + 0.082*y2  - 0.097*y3  + 0.068*y4  - 0.027*y5  + 0.0061*y6  - 0.00073*y7            );
  double Fnn= CJ*exp(-2*y)*(0.49    - 3.3*y   + 8.8*y2    - 12.*y3    + 9.8*y4    - 4.5*y5    + 1.2*y6     - 0.16*y7  + 0.010*y8
                           +0.25    - 0.84*y  + 1.4*y2    - 1.5*y3    + 0.94*y4   - 0.37*y5   + 0.089*y6   - 0.012*y7 + 0.00076*y8 );
//printf("J=%E CJ=%E CJ*(2*J+1)/M_PI=%E\n", J,CJ,CJ*(2*J+1)/M_PI);
//printf("129:  Fpp=%E Fnp=%E Fnn=%E\n",Fpp,Fpn,Fnn);  
 *S00=   (2*J+1)/M_PI*(Fpp+Fnn+2*Fpn);
 *S11=   (2*J+1)/M_PI*(Fpp+Fnn-2*Fpn);
 *S01= 2*(2*J+1)/M_PI*(Fpp-Fnn);
}

void SxxXe131EFT(double q,double*S00,double*S01,double*S11) 
{

  double A=131, J=J_Xe131;
  double b=sqrt(41.467/(45*pow(A,-1./3.) -25*pow(A,-2./3)));
  double y=pow(b*q/2,2);


  double CJ=J*(J+1)/12;
  double y2=y*y, y3=y*y2, y4=y*y3, y5=y*y4, y6=y*y5,y7=y*y6, y8=y*y7;
     
  double Fpp= CJ*exp(-2*y)*(0.00012 - 0.00089*y + 0.0015*y2  + 0.0015*y3  - 0.00069*y4 - 0.0012*y5  + 0.00080*y6 - 0.00016*y7
                                                + 0.00013*y2 - 0.00062*y3 + 0.00088*y4 - 0.00053*y5 + 0.00015*y6                         );
  double Fpn= CJ*exp(-2*y)*(0.0045  - 0.039*y   + 0.095*y2   - 0.038*y3   - 0.077*y4   + 0.087*y5   - 0.035*y6   + 0.0059*y7 - 0.00035*y8
                           +0.0023  + 0.0032*y  - 0.011*y2   - 0.00077*y3 + 0.019*y4   - 0.018*y5   + 0.0066*y6  - 0.0011*y7             );
  double Fnn= CJ*exp(-2*y)*(0.18    - 1.6*y     + 5.8*y2     - 9.7*y3     + 9.1*y4     - 4.9*y5     + 1.4*y6     - 0.21*y7   + 0.012*y8
                           +0.088   + 0.30*y    - 0.23*y2    - 0.47*y3    + 1.2*y4     - 1.1*y5     + 0.44*y6    - 0.086*y7  + 0.0067*y8 );

 *S00=   (2*J+1)/M_PI*(Fpp+Fnn+2*Fpn);
 *S11=   (2*J+1)/M_PI*(Fpp+Fnn-2*Fpn);
 *S01= 2*(2*J+1)/M_PI*(Fpp-Fnn);
}


// =================== SHELL  1304.7684 


static void _SxxF19SHELL_(double q,double*S00,double*S01,double*S11, int minFlag ) 
{

  double data00[15] ={ 0.108058,  -0.143789,  0.0680848,  4.07415E-4, -0.0314817,  0.0385933, -0.0293716,  0.0152264, -0.00552655,  0.00141965, -2.56989E-4,  3.20688E-5, -2.62562E-6,  1.26950E-7, -2.74719E-9};
  double data11m[15]={ 0.0505180, -0.102657,  0.111644,  -0.103800,    0.0920875, -0.0693892,  0.0406756, -0.0180247,  0.00597662, -0.00146688,  2.61654E-4, -3.28624E-5,  2.74752E-6, -1.36980E-7,  3.07589E-9};
  double data11p[15]={ 0.0815382, -0.172679,  0.212269,  -0.228208,    0.213050,  -0.153539,   0.0811970, -0.0312282,  0.00872716, -0.00176305,  2.53666E-4, -2.52190E-5,  1.63658E-6, -6.18772E-8,  1.02158E-9};
  double data01m[15]={ 0.147769,  -0.248324,  0.196804,  -0.110517,    0.0431978,  0.00355133,-0.0214773,  0.0171137, -0.00777410,  0.00231495, -4.67535E-4,  6.36451E-5, -5.60211E-6,  2.88239E-7, -6.58792E-9};
  double data01p[15]={ 0.187748,  -0.324839,  0.292189,  -0.243481,    0.225724,  -0.187879,   0.120370,  -0.0567987,  0.0195241,  -0.00485435,  8.61430E-4, -1.06203E-4, 8.63415E-6,  -4.15920E-7,  8.98798E-9};

  double dataPm[15]={  0.306344,   -0.494703,    0.375778,   -0.210605,   0.0963209,  -0.0171498, -0.0189635,  0.0194977, -0.00944981,  0.00288142, -5.87122E-4,  8.01160E-5, -7.04748E-6,  3.61875E-7, -8.24953E-9};
  double dataPp[15]={  0.377350,   -0.641645,    0.575714,   -0.482204,   0.426127,   -0.322095,   0.185010,  -0.0786211,  0.0245769,  -0.00561387,  9.23589E-4, -1.06384E-4,  8.13277E-6, -3.70365E-7,  7.60000E-9};
  double dataNm[15]={  0.00186788,  0.00680710,  0.00639787, -0.0611310,  0.114287,   -0.118072,   0.0795624, -0.0371512,  0.0123395,  -0.00293887,  4.98543E-4, -5.88110E-5,  4.58527E-6, -2.12430E-7,  4.42852E-9};
  double dataNp[15]={  0.0108048,   0.00209733, -0.0195694,   0.0180694, -0.00732843, -0.00123149, 0.00434979,-0.00349429, 0.00167052, -5.31956E-4,  1.15596E-4, -1.69465E-5,  1.60329E-6, -8.83654E-8,  2.15466E-9};

  double b=1.8032;  // fm
  double u=q*q*b*b/2;
  double un=u;
  int dim=15;
  int sgn=-1; // because <Sp>/<Sn> <0
  if(minFlag==0)
  {           
     *S00=data00[0],*S01=(data01p[0]+data01m[0])/2; *S11=(data11p[0]+data11m[0])/2 ;
     for(int i=1;i<dim;i++) { *S00+=un*data00[i];*S01+=un*(data01p[i]+data01m[i])/2 ;*S11+=un*(data11p[i]+data11m[i])/2; un*=u;}
  } else
  {  double Sp,Sn; 
     {
       Sp=dataPm[0], Sn=dataNm[0];
       for(int i=1;i<dim;i++) { Sp+=un*dataPm[i];Sn+=un*dataNm[i]; un*=u;}
     } 
     *S00=(Sp+Sn+2*sgn*sqrt(fabs(Sp*Sn)))/4;
     *S11=(Sp+Sn-2*sgn*sqrt(fabs(Sp*Sn)))/4;
     *S01=(Sp-Sn)/2.;
  }
  *S00*=exp(-u); *S01*=exp(-u); *S11*=exp(-u); 
}



static void _SxxXe129SHELL_(double q,double*S00,double*S01,double*S11,int minFlag)
{

  double data00[10] ={ 0.0547144, -0.146407,  0.180603, -0.125526,  0.0521484, -0.0126363,  0.00176284, -1.32501E-4, 4.23423E-6, -1.68052E-9};
  double data11m[10]={ 0.0221559, -0.0656100, 0.0863920,-0.0631729, 0.0278792, -0.00756661, 0.00126767, -1.27755E-4, 7.10322E-6, -1.67272E-7};
  double data11p[10]={ 0.0357742, -0.107895,  0.145055, -0.108549,  0.0490401, -0.0136169,  0.00233283, -2.39926E-4, 1.35553E-5, -3.21404E-7};
  double data01m[10]={-0.0885644,  0.254049, -0.332322,  0.244981, -0.109298,   0.0296705, -0.00492657,  4.88467E-4,-2.65022E-5,  5.98909E-7};
  double data01p[10]={-0.0696691,  0.197380, -0.254839,  0.185896, -0.0825294,  0.0224322, -0.00375109,  3.77179E-4,-2.09510E-5,  4.92362E-7};

  double dataPm[10]={ 0.00196369,-0.00119154,-0.00324210, 0.00622602,-0.00496653, 0.00224469,-5.74412E-4, 8.31313E-5,-6.41114E-6, 2.07744E-7};
  double dataPp[10]={ 0.00715281,-0.0134790,  0.00788823, 0.00311153,-0.00653771, 0.00375478,-0.00105558, 1.59440E-4,-1.25055E-5, 4.04987E-7};
  double dataNm[10]={ 0.146535,  -0.409290,   0.521423,  -0.374011,   0.162155,  -0.0424842,  0.00674911,-6.33434E-4, 3.20266E-5,-6.54245E-7};
  double dataNp[10]={ 0.179056,  -0.508334,   0.657560,  -0.477988,   0.209437,  -0.0554186,  0.00889251,-8.42977E-4, 4.30517E-5,-8.88774E-7};

  double b=2.2853; // fm
  double u=q*q*b*b/2;
  double un=u;
  int dim=10;  
  int sgn=1; // because <Sp>/<Sn> >0
  if(minFlag==0)
  {           
     *S00=data00[0],*S01=(data01p[0]+data01m[0])/2; *S11=(data11p[0]+data11m[0])/2 ;
     for(int i=1;i<dim;i++) { *S00+=un*data00[i];*S01+=un*(data01p[i]+data01m[i])/2 ;*S11+=un*(data11p[i]+data11m[i])/2; un*=u;}
  } else
  {  double Sp,Sn; 
     {
       Sp=dataPm[0], Sn=dataNm[0];
       for(int i=1;i<dim;i++) { Sp+=un*dataPm[i];Sn+=un*dataNm[i]; un*=u;}
     } 

     *S00=(Sp+Sn+2*sgn*sqrt(fabs(Sp*Sn)))/4;
     *S11=(Sp+Sn-2*sgn*sqrt(fabs(Sp*Sn)))/4;
     *S01=(Sp-Sn)/2.;
  }
  *S00*=exp(-u); *S01*=exp(-u); *S11*=exp(-u); 
}


static void _SxxXe131SHELL_(double q,double*S00,double*S01,double*S11,int minFlag) // Menendez et al.;  1208.1094
{

  double data00[10] ={ 0.0417857, -0.111132,   0.171306,  -0.132481,  0.0630161, -0.0177684,  0.00282192, -2.32247E-4,  7.81471E-6, 1.25984E-9};
  double data11m[10]={ 0.0167361, -0.0472853,  0.0684924, -0.0514413, 0.0237858, -0.00692778, 0.00124370, -1.31617E-4,  7.46669E-6,-1.73484E-7};
  double data11p[10]={ 0.0271052, -0.0812985,  0.122960,  -0.0940491, 0.0439746, -0.0128013,  0.00227407, -2.35642E-4,  1.28691E-5,-2.77011E-7};
  double data01m[10]={-0.0675438,  0.195710,  -0.306688,   0.243678, -0.118395,   0.0351428, -0.00622577,  6.31685E-4, -3.33272E-5, 6.82500E-7};
  double data01p[10]={-0.0529487,  0.146987,  -0.225003,   0.179499, -0.0888278,  0.0271514, -0.00499280,  5.31148E-4, -2.99162E-5, 6.81902E-7};

  double dataPm[10]={ 0.00159352, -0.00207344,  0.00567412, -0.00605643, 0.00337794, -6.88135E-4  ,-3.42717E-5 , 3.13222E-5, -4.02617E-6,  1.72711E-7};   
  double dataPp[10]={ 0.00529643, -0.00528808, -0.00627452,  0.0227436, -0.0192229 ,  0.00844826  ,-0.00212755 , 3.03972E-4, -2.27893E-5,  7.05661E-7};  
  double dataNm[10]={ 0.111627  , -0.308602  ,  0.474842,   -0.375201 ,  0.182382  , -0.0539711   , 0.00944180 ,-9.34456E-4,  4.73386E-5, -9.01514E-7};  
  double dataNp[10]={ 0.136735,   -0.393930,    0.617924,   -0.488443,   0.234645,   -0.0681357,    0.0116393,  -0.00111487,  5.34878E-5, -9.03594E-7};


  double*data01=data01m;
  double*data11=data11m;

  double b=2.2905;  // fm 
  double u=q*q*b*b/2;
  double sgn=1;
  double un=u;
  int dim=10;  

  if(minFlag==0)
  {           
     *S00=data00[0],*S01=(data01p[0]+data01m[0])/2; *S11=(data11p[0]+data11m[0])/2 ;
     for(int i=1;i<dim;i++) { *S00+=un*data00[i];*S01+=un*(data01p[i]+data01m[i])/2 ;*S11+=un*(data11p[i]+data11m[i])/2; un*=u;}
  } else
  {  double Sp,Sn; 
     {
       Sp=dataPm[0], Sn=dataNm[0];
       for(int i=1;i<dim;i++) { Sp+=un*dataPm[i];Sn+=un*dataNm[i]; un*=u;}
     }

     *S00=(Sp+Sn+2*sgn*sqrt(fabs(Sp*Sn)))/4;
     *S11=(Sp+Sn-2*sgn*sqrt(fabs(Sp*Sn)))/4;
     *S01=(Sp-Sn)/2.;
  }
  *S00*=exp(-u); *S01*=exp(-u); *S11*=exp(-u); 
}


void SxxF19SHELL(double q,double*S00,double*S01,double*S11)  { _SxxF19SHELL_(q,S00,S01,S11,0); }
void SxxXe129SHELL(double q,double*S00,double*S01,double*S11){ _SxxXe129SHELL_(q,S00,S01,S11,0);}
void SxxXe131SHELL(double q,double*S00,double*S01,double*S11){ _SxxXe131SHELL_(q,S00,S01,S11,0);}

void SxxF19SHELLm(double q,double*S00,double*S01,double*S11)  { _SxxF19SHELL_(q,S00,S01,S11,1); }
void SxxXe129SHELLm(double q,double*S00,double*S01,double*S11){ _SxxXe129SHELL_(q,S00,S01,S11,1);}
void SxxXe131SHELLm(double q,double*S00,double*S01,double*S11){ _SxxXe131SHELL_(q,S00,S01,S11,1);}
